#include <Sharp-IR.h>

const uint32_t SHARP_IR_INTERVAL = 100;

bool SharpIR::getDistance(float& distance)
{
    bool newReading = false;
    uint32_t currTime = millis();
    if(currTime - lastReading >= SHARP_IR_INTERVAL)
    {
        lastReading = currTime;

        uint16_t adcResult = analogRead(adcPin);
        float voltage = (adcResult*(5.0/1023.0));
      	distance = 24.071/(voltage - 0.0716);

        newReading = true;
    }

    return newReading;
}
